// Copyright: Michael Moerz 2000
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License with
// the Debian GNU/Linux distribution in file /usr/share/doc/common-licenses/GPL
// if not, write to the Free Software Foundation, Inc., 59 Temple Place,
// Suite 330, Boston, MA  02111-1307  USA

#ifndef DRF_LIST_H
#define DRF_LIST_H 1

typedef struct dlist {
  struct dlist* next;
  struct dlist* prev;
  void* data;
} DList;

extern DList* dlist_new        (void* data);
extern void   dlist_cat        (DList* tail_l1, DList* head_l2);
extern DList* dlist_insertnew  (DList** tail, void* data);
extern DList* dlist_insert     (DList** tail, DList* new);
extern DList* dlist_head       (DList* head);
extern DList* dlist_tail       (DList* head);
extern size_t dlist_length     (DList* head);
extern DList* dlist_remove     (DList** head, DList** tail, DList* entry);

#endif /* !DRF_LIST_H */
